﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGridDeactivateWholeRow
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private List<Person> _personenList;

        public List<Person> PersonenList
        {
            get { return _personenList; }
            set { _personenList = value; OnPropertyChanged(); }
        }


        public MainWindow()
        {
            InitTestData();
            DataContext = this;
            InitializeComponent();
        }

        public event PropertyChangedEventHandler PropertyChanged;       
        
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            if (PropertyChanged == null)
                return;

            PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        private void InitTestData()
        {
            var _newList = new List<Person>();
            for (var i = 0; i < 1000; i++)
            {
                _newList.Add(new Person(i));
            }
            PersonenList = _newList;
        }

        private void ClickedReset(object sender, RoutedEventArgs e)
        {
            InitTestData();
        }
    }

    public class Person : INotifyPropertyChanged
    {
        public Person()
        {

        }

        public Person(int number)
        {
            _age = number % 50;
            _name = "Name " + number;
            _bankAccount = number * 100;
            _isEditable = number % 2 == 1;
        }

        private int _age;

        public int Age
        {
            get { return _age; }
            set { _age = value; OnPropertyChanged(); }
        }


        private string _name;

        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged(); }
        }

        private int _bankAccount;

        public int BankAccount
        {
            get { return _bankAccount; }
            set { _bankAccount = value; OnPropertyChanged(); }
        }

        private Guid _id1;

        public Guid Id1
        {
            get { return _id1; }
            set { _id1 = value;
            OnPropertyChanged();
            }
        }

        private Guid _id2;

        public Guid Id2
        {
            get { return _id2; }
            set { _id2 = value;
            OnPropertyChanged();
            }
        }

        private bool _isEditable;

        public bool IsEditable
        {
            get { return _isEditable; }
            set { _isEditable = value; OnPropertyChanged(); }
        }

        







        public event PropertyChangedEventHandler PropertyChanged;        
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            if (PropertyChanged == null)
                return;

            PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
